package com.kingdee.eas.custom.risheng;

import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.log4j.Logger;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.utils.StringUtils;
import com.kingdee.bos.*;

import java.lang.String;

import com.kingdee.eas.base.wssc.app.trd.webservice.WebServiceConfig;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.risheng.util.HttpRequestSecUtil;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;

public class RishengHaiKangHRFacadeControllerBean extends AbstractRishengHaiKangHRFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.risheng.RishengHaiKangHRFacadeControllerBean");
    /**
     * ֯ͬ
     */
    @Override
    public String syncAdminOrg(Context ctx, String data) throws BOSException, EASBizException {
    	System.out.println("֯ͬӿ");
	    JSONObject returnData = new JSONObject();
    	returnData.put("success", true);
    	returnData.put("message", "OK");
    	try {
	    	Calendar beforeTime = Calendar.getInstance();
		    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	        beforeTime.add(Calendar.MINUTE, -5);// 5֮ǰʱ
	        Date beforeD = beforeTime.getTime();
	        String before5 = simpleDateFormat.format(beforeD);
	        String depSql = "";
	        System.out.println("Ϊ"+data.toString());
			Set<String> set = new HashSet<String>();
			String needUpSql = "";
	        if(!StringUtils.isEmpty(data)){
	        	needUpSql = "SELECT FID as id,FNAME_l2 AS NAME,FNUMBER AS CODE,FPARENTID AS PARENT_DEPT  FROM T_ORG_ADMIN  where  fid = '"+data+"'";
	        	IRowSet depSet = DbUtil.executeQuery(ctx, needUpSql);
	        	while(depSet.next()){
	        		String dep_code = depSet.getString("CODE");
	        		set.add(dep_code);
	        	}
	        }else{
	        	depSql = "SELECT b.FID as id,b.FNAME_l2 AS NAME,b.FNUMBER AS CODE,b.FPARENTID AS PARENT_DEPT  " +
	        			"FROM T_ORG_BASEUNIT  a " +
	        			"left join t_org_admin b on a.fid = b.fid " +
	        			"where  to_char(a.FLASTUPDATETIME ,'yyyy-MM-dd HH24:mi:ss') >= '"+before5+"' " +
	        			"or to_char(b.FLASTUPDATETIME ,'yyyy-MM-dd HH24:mi:ss') >= '"+before5+"' ";
	        	IRowSet depSet = DbUtil.executeQuery(ctx, depSql);
	        	while(depSet.next()){
	        		String dep_code = depSet.getString("CODE");
	        		set.add(dep_code);
	        	}
	        }
	        System.out.println("set==="+set.toString());
	        for(String pNumber :set){
	        	String upSql = "/*dialect*/ update t_org_admin Set CFToHKisNew = '1' where fnumber = '"+pNumber+"'";
	        	DbUtil.execute(ctx,upSql);
	        }
	        if(StringUtils.isEmpty(data)){
	        	needUpSql = "/*dialect*/ select fid id,fname_l2 NAME,FNUMBER CODE,FPARENTID PARENT_DEPT from t_org_admin where CFToHKisNew = '1'";
	        }
			System.out.println("needUpSql="+needUpSql);
			IRowSet needUpSet = DbUtil.executeQuery(ctx, needUpSql);
			while(needUpSet.next()){
				String timestamp = System.currentTimeMillis()/1000+"";
			    System.out.println("ʱΪ"+timestamp);
			    String depId = "";//֯ID
			    String depName = "";//֯
			    String depCode = "";//֯
			    String parent_ID = "";//ϼ֯ID
			    String invalid = "0"; //״̬
			    depId = needUpSet.getString("id");
			    depName = needUpSet.getString("NAME");
			    depCode = needUpSet.getString("CODE");
			    parent_ID = needUpSet.getString("PARENT_DEPT");
	    		//Ƿ ߼Ҫж
	    		String isSealUpSql = "SELECT FIsSealUp,FIsOUSealUp FROM T_ORG_Admin WHERE FNUMBER = '"+depCode+"'";
	    		IRowSet isSealUpSet = DbUtil.executeQuery(ctx, isSealUpSql);
	    		while(isSealUpSet.next()){
	    			if("0".equals(isSealUpSet.getString("FIsSealUp") )&& "0".equals(isSealUpSet.getString("FIsOUSealUp"))){
	    				invalid = "1";
	    			}
	    		}
	    		JSONObject json = new JSONObject();
	    		json.put("depId",depId);
	    		json.put("depName",depName);
	    		json.put("depCode",depCode);
	    		json.put("parent_ID",parent_ID);
	    		json.put("invalid",invalid);
	    		json.put("timestamp",timestamp);
	    		CloseableHttpClient httpClient = null;
	    		String resultStr = "";
	    		httpClient = HttpClients.createDefault();
    			Map<String, String> headMap = new HashMap<String, String>();
    			headMap.put("accept", "*/*");
    			headMap.put("connection", "Keep-Alive");
    			headMap.put("Content-Type", "application/json");
    			System.out.println("֯ͬΪ"+json.toJSONString());
    			System.out.println("֯ͬͷΪ"+headMap.toString());
    			String TEST_BASEURL = WebServiceConfig.getPropertiesValue(ctx, "rishengBaseUrl");
    			//ַȷ
		 		String url = TEST_BASEURL+"/xxxxxx";
		 		resultStr = HttpRequestSecUtil.sendPost(url, json.toString(), headMap);
		 		JSONObject res = JSONObject.parseObject(resultStr);
		 		String code = res.getString("code");
		 		String message = res.getString("message");
		 		if("true".equals(message)){
		 			String updateSQL2 = "/*dialect*/ update t_org_admin Set CFToHKisNew = '0' where fid = '"+depId+"'";
		 			DbUtil.execute(ctx, updateSQL2);
		 		}else{
		 			returnData.put("success", false);
					returnData.put("message", message);
		 		}
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println(e.getMessage());
			returnData.put("success", false);
			returnData.put("message", e.getMessage());
		}
    	
        return returnData.toJSONString();
    }
    /**
     * Աְͬ
     */
    @Override
    public String syncEmpLeaves(Context ctx, String data) throws BOSException, EASBizException {
    	// TODO Զɵķ
    	return super.syncEmpLeaves(ctx, data);
    }
    /**
     * Աְָͬ
     */
    @Override
    public String syncEmpLeavesRestore(Context ctx, String data) throws BOSException, EASBizException {
    	// TODO Զɵķ
    	return super.syncEmpLeavesRestore(ctx, data);
    }
    /**
     * Աͬ
     */
    @Override
    public String syncPerson(Context ctx, String data) throws BOSException, EASBizException {
    	// TODO Զɵķ
    	return super.syncPerson(ctx, data);
    }
}