package com.kingdee.eas.custom.risheng;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

import org.apache.axis.encoding.Base64;
import org.apache.log4j.Logger;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import com.kingdee.bos.*;
import com.kingdee.bos.workflow.AssignmentInfo;
import com.kingdee.bos.workflow.service.ormrpc.EnactmentServiceFactory;
import com.kingdee.bos.workflow.service.ormrpc.IEnactmentService;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.String;
import java.net.URLEncoder;

import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.risheng.util.HttpRequestUtil;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.util.StringUtils;

public class RishengPendingMessageFacadeControllerBean extends AbstractRishengPendingMessageFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.risheng.RishengPendingMessageFacadeControllerBean");
    private static final String ROOT_URL = "http://120.46.132.160:8080/rest/ofs/ReceiveRequestInfoByJson";
    private static final String SHR_ROOT_URL = "https://rshr.kdeascloud.com";
	private static final String EID = "K172K145K108K99K97";
	
//	private static final String TOKEN_URL = "/seeyon/rest/token";
//	private static final String AUTHEN_NAME = "0003";
//	private static final String AUTHEN_PASSWORD = "123456";
	
	/**
	 * Ϣ͵OA
	 */
    @Override
    public String sendPendingMsg(Context ctx, String data) throws BOSException, EASBizException {
    	// TODO Զɵķ
		try{
			StringBuffer queryPendingSqlBuf = new StringBuffer(
					" /*dialect*/ SELECT ");
			queryPendingSqlBuf.append("b.FID");
			queryPendingSqlBuf.append(",a.FSUBJECT_l2 TITLE");
			queryPendingSqlBuf.append(",b.FSenderId SENDERID");
			queryPendingSqlBuf.append(",d.FNUMBER SENDERNUMBER");
			queryPendingSqlBuf.append(",b.FSender_l2 SENDERNAME");
			queryPendingSqlBuf.append(",a.FPERSONUSERID RECEIVERID");
			queryPendingSqlBuf.append(",e.FNUMBER RECEIVERNUMBER");
			queryPendingSqlBuf.append(",a.FPERSONUSERNAME_L2 RECEIVERNAME");
			queryPendingSqlBuf.append(",a.FCREATEDTIME SENDTIME");
			queryPendingSqlBuf.append(",a.FCREATEDTIME RECEIVETIME");
			queryPendingSqlBuf.append(",a.FPRIORITY PRIORITY");
			queryPendingSqlBuf.append(",b.FSTATUS STATUS");
			queryPendingSqlBuf.append(",a.FSTATE SOURCESTATUS");
			queryPendingSqlBuf.append(",b.FORGTYPE ORGTYPE");
			queryPendingSqlBuf.append(",b.FORGID ORGID");
			queryPendingSqlBuf.append(",a.FASSIGNID SOURCEID");
			queryPendingSqlBuf.append(",b.FIsWebSupport ISWEBSUPPORT");
			queryPendingSqlBuf.append(",a.FBODY_l2 FBODY");
			queryPendingSqlBuf.append(",a.FPROCDEFNAME_l2 PROCDEFNAME");
			queryPendingSqlBuf.append(",b.FTag_l2 TAG");
			queryPendingSqlBuf.append(",b.FSenderId SENDERID");
			queryPendingSqlBuf.append(",b.FPriorPerformerID PRIORPERFORMERID");
			queryPendingSqlBuf.append(",last.FNumber PRIORPERFORMNAME");
			queryPendingSqlBuf.append(",a.FPROCINSTID FPROCINSTID");
			queryPendingSqlBuf.append(",a.FBIZOBJID FBIZOBJID");
			queryPendingSqlBuf.append(",e.fname_l2 ename");
			queryPendingSqlBuf.append(" FROM T_WFR_Assign a");
			queryPendingSqlBuf.append(" INNER JOIN T_BAS_AssignRead b ON a.FASSIGNID = b.FASSIGNID");
			queryPendingSqlBuf.append(" JOIN T_PM_User last ON b.FPriorPerformerID = last.FID");
			queryPendingSqlBuf.append(" JOIN T_PM_User d ON b.FSenderId = d.FID");
			queryPendingSqlBuf.append(" JOIN T_PM_User e ON a.FPERSONUSERID = e.FID");
			queryPendingSqlBuf.append(" WHERE a.FIsSendMsg = 1 and  a.CFISSYS is null and e.Fnumber not in ('user','administrator')");
			String queryPend = queryPendingSqlBuf.toString();
			if(null != data && !"".equals(data)){
				queryPend = queryPend + " and a.FCREATEDTIME  >= '"+ data + "'";
			}
			System.out.println("ѯSQL:" + queryPend);
			IRowSet queryPendingRows = DbUtil.executeQuery(ctx, queryPend);
			System.out.println("췢" + queryPendingRows.size());
			System.out.println("userQueryTime===================" + new Date());
			System.out.println("ʼʱ===================" + new Date());
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			while(queryPendingRows.next()){
				Map<String, Object> queryPendingMap = new HashMap<String, Object>();
				String taskId = queryPendingRows.getString("SOURCEID");
				queryPendingMap.put("syscode", "SHR");//칹ϵͳʶ
				queryPendingMap.put("flowid", taskId);// ID
				queryPendingMap.put("requestname", queryPendingRows.getString("TITLE"));// 
				queryPendingMap.put("workflowname", queryPendingRows.getString("PROCDEFNAME"));// 
				queryPendingMap.put("nodename", "1");// 
				String url = getUrl(queryPendingRows.getString("RECEIVERNUMBER"),taskId) ;	
				queryPendingMap.put("pcurl",url);// pcַ
				
				
				String FBIZOBJID =  queryPendingRows.getString("FBIZOBJID");// ҵ
				String rcvNum = queryPendingRows.getString("RECEIVERNUMBER");  //ʱΪ0003
			//	String rcvNum = "0003";
				String receiverNumberBase = Base64.encode(rcvNum.getBytes());
				String mbosUrl = getUrl(taskId, EID, "https://mbos.kdeascloud.com/mbos/page/loadPage?", "10036", ctx,FBIZOBJID);
				mbosUrl = mbosUrl+"&token="+receiverNumberBase+"&isOtherApp=true&path=lczs2";
				
				System.out.println("mbos ========"+mbosUrl);
				queryPendingMap.put("appurl", mbosUrl);//appַ
				queryPendingMap.put("isremark", "0");// ״̬ 0:δ2:Ѱ
				queryPendingMap.put("viewtype", "0");// ̲鿴״̬
				//ˣΪ0003 
				String cjrNumber = queryPendingRows.getString("SENDERNUMBER");
				String cjr = cjrNumber.substring(0, 1);
				if(cjr.equals("1")||cjr.equals("2")){
					cjrNumber=cjrNumber.substring(1, cjrNumber.length());
				}
				//queryPendingMap.put("creator", "0003"); 
				queryPendingMap.put("creator", cjrNumber); 
				//ˣΪ0003
				String jsrNumber = queryPendingRows.getString("RECEIVERNUMBER");
				String substring = jsrNumber.substring(0, 1);
				if(substring.equals("1")||substring.equals("2")){
					jsrNumber=jsrNumber.substring(1, jsrNumber.length());
				}
			//	queryPendingMap.put("receiver", "0003");// ID
				queryPendingMap.put("receiver", jsrNumber);// ID
				Date createTime = queryPendingRows.getDate("RECEIVETIME");
				queryPendingMap.put("createdatetime", sdf.format(createTime));// ̴ʱ
				queryPendingMap.put("receivedatetime", sdf.format(createTime));// 
				queryPendingMap.put("receivets",new Date().getTime()+"");// ʱ			
				System.out.println("췢(" + new Date().getTime() + ")"+ JSONObject.fromObject(queryPendingMap).toString());
				try{
					String resultMsgDataStr = HttpRequestUtil.sendPost(ROOT_URL ,JSONObject.fromObject(queryPendingMap).toString(), "json");			
					System.out.println("ӿڷϢ(" + new Date().getTime() + ")"+ resultMsgDataStr);
					JSONObject resultData = JSONObject.fromObject(resultMsgDataStr);
					if(resultData.getString("operResult").equals("1")){
						//±T_WFR_Assign ״̬
						DbUtil.execute(ctx,"update T_WFR_Assign set CFISSYS = 0 where FASSIGNID = '"+ taskId + "'");
					}else{
						String resultDataArr = resultData.get("messgae")==null?"":resultData.get("messgae").toString();
						System.out.println("ʹشʧܣʧԭΪ"+ resultDataArr);
					}
				}catch(Exception e){
					e.printStackTrace();
					System.out.println(e.getMessage());
				}
			}
			System.out.println("endʱ===================" + new Date());
		}catch(SQLException e){
			e.printStackTrace();
			System.out.println(e.getMessage());
		}
    	return null;
    }

    private static String getUrl(String username ,String assignid) {
		String url ="";
		url=SHR_ROOT_URL+"/portal/index2sso.jsp?username="+username+"&billType=1&redirectTo="+URLEncoder.encode(SHR_ROOT_URL+"/easweb/webviews/workflow/transferApprove.jsp?AssignmentId="+assignid);
		return url;
	}
    private static String getMobileUrl(String username ,String assignid,String procInId){
    	return SHR_ROOT_URL+"/approve/#/ApproveApp/ApvDetail?assignId="+assignid+"&receiverId="+username+"&procInstId="+procInId;
    }
	public Map<String, Object> getValue(String fileName) {
		if(!fileName.contains(".properties")){
			fileName += ".properties";
		}
		Map<String, Object> map = new HashMap<String, Object>();
		Properties properties = new Properties();
		InputStream in = null;
		try{
			in = new BufferedInputStream(new FileInputStream(System.getProperty("EAS_HOME")+ "/server/properties/" + fileName));
			properties.load(in);
			for(Object key : properties.keySet()){
				String keyStr = key.toString();
				String value = properties.getProperty(keyStr);
				map.put(keyStr, value);
			}
		}catch(Exception e){
			e.printStackTrace();
			System.out.println(e.getMessage());
		}finally{
			if(in != null){
				try{
					in.close();
				}catch(IOException e){
					e.printStackTrace();
				}
			}
		}
		return map;
	}
	
	private String getUrl(String assignid, String eid, String host, String appId,Context ctx,String billId)
	throws BOSException {
		String newEid =EID;
		//logger.info("XT Message newEidnewEid=" + newEid);
		String url = host;
		IEnactmentService svc = EnactmentServiceFactory.createEnactService(ctx);
		AssignmentInfo info = svc.getAssignmentById(assignid);
		if(host.indexOf("?") > -1){
			String actdef = info.getActDefId();
			System.out.println("actdef==================="+actdef);
			String procdef = info.getProcDefId();
			System.out.println("procdef==================="+procdef);
			String mbosUrl = getMbosUrl(procdef, actdef,ctx);
			System.out.println("mbosUrl=================="+mbosUrl);
			if(!(StringUtils.isEmpty(mbosUrl))){
				mbosUrl = mbosUrl.replace("page/loadPage","mbosw/getWorkflowUrl");
				url = mbosUrl + "&eid=" + newEid + "&assignId=" + assignid+ "&appid=" + appId + "&billID="+URLEncoder.encode(billId);
				return url;
			}
		}
		if(host.indexOf("?") > -1)
			//url = url + "&storeEid=K172K145K108K99K97&name=approveui.navui&eid=" + newEid+ "&assignId=" + assignid + "&appid=" + appId;
			url = url + "storeEid=K172K145K108K99K97&name=approveui.navui&eid=" + newEid+ "&assignId=" + assignid + "&appid=" + appId;
		else{
			url = url + "/dealWithNotice.html?eid=" + newEid + "&assignId="+ assignid + "&appid=" + appId;
		}
		return url;
	}
	
	private String getMbosUrl(String procid, String actDefId,Context ctx) {
		String url = "";
		try{
			StringBuffer sql = new StringBuffer("SELECT url FROM T_WFR_MBOS_WORKFLOW  ");
			if(!(StringUtils.isEmpty(actDefId))){
				sql.append(" WHERE actDefId in ('" + actDefId + "')");
			}
			if(!(StringUtils.isEmpty(procid))){
				sql.append(" and procdefid in ('" + procid + "')");
			}
			IRowSet rowSet = DbUtil.executeQuery(ctx, sql.toString());
			if(rowSet.next()){
				url = rowSet.getString("url");
			}
		}catch(Exception e){
			//logger.error(e.getMessage(), e);
		}
		return url;
	}
    /**
     * ѰϢ͵OA
     */
    @Override
    public String sendDoneMsg(Context ctx, String data) throws BOSException, EASBizException {
    	// TODO Զɵķ
    	StringBuffer queryUpdatePendSqlBuf = new StringBuffer(" /*dialect*/ SELECT ");
			queryUpdatePendSqlBuf.append("a.FASSIGNID");
			queryUpdatePendSqlBuf.append(",a.FPROCINSTID");
			queryUpdatePendSqlBuf.append(",a.FSTATE AFSTATE");
			queryUpdatePendSqlBuf.append(",a.FSUBJECT_l2 TITLE");
			queryUpdatePendSqlBuf.append(",e.FNUMBER RECEIVERNUMBER");
			queryUpdatePendSqlBuf.append(",a.fprocdefname_l2 PROCDEFNAME");
			queryUpdatePendSqlBuf.append(",d.fnumber SENDERNUMBER");
			queryUpdatePendSqlBuf.append(",a.fcreatedtime RECEIVETIME");
			queryUpdatePendSqlBuf.append(",b.FSTATE");
			queryUpdatePendSqlBuf.append(",c.FISPASS");
			queryUpdatePendSqlBuf.append(",a.FBIZOBJID FBIZOBJID");
			queryUpdatePendSqlBuf.append(" FROM t_wfr_AssignDetail a");
			queryUpdatePendSqlBuf.append(" JOIN T_WFR_ProcInst b ON a.FPROCINSTID = b.FPROCINSTID");
			queryUpdatePendSqlBuf.append(" LEFT JOIN T_BAS_MultiApprove c ON a.FASSIGNID = c.FASSIGNMENTID");
			queryUpdatePendSqlBuf.append(" JOIN T_PM_User e ON a.FPERSONUSERID = e.FID");
			queryUpdatePendSqlBuf.append(" JOIN T_PM_User d ON a.fpriorperformer = d.FID");
			queryUpdatePendSqlBuf.append(" WHERE (a.FSTATE = 16 OR a.FSTATE = 4) AND a.CFISSYS is null  and e.Fnumber not in ('user','administrator')");	
		this.sendDone(ctx, queryUpdatePendSqlBuf);
		return null;
    }
    private int sendDone(Context ctx, StringBuffer queryUpdatePendSqlBuf)throws BOSException 
    {
		System.out.println("ѯѰSQL:" + queryUpdatePendSqlBuf.toString());
		IRowSet queryUpfatePendRows = DbUtil.executeQuery(ctx,queryUpdatePendSqlBuf.toString());
		System.out.println("Ѱ췢" + queryUpfatePendRows.size());
		try{
			System.out.println("ʼʱ===================" + new Date());
			while(queryUpfatePendRows.next()){
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
				Map<String, Object> queryPendingMap = new HashMap<String, Object>();
				String taskId = queryUpfatePendRows.getString("FASSIGNID");
				queryPendingMap.put("syscode", "SHR");//칹ϵͳʶ
				queryPendingMap.put("flowid", taskId);// ID
				queryPendingMap.put("requestname", queryUpfatePendRows.getString("TITLE"));// 
				queryPendingMap.put("workflowname", queryUpfatePendRows.getString("PROCDEFNAME"));// 
				queryPendingMap.put("nodename", "1");// 
				queryPendingMap.put("viewtype", "0");// ̲鿴״̬
				String cjrNumber = queryUpfatePendRows.getString("SENDERNUMBER");
				queryPendingMap.put("creator", cjrNumber);//   ʱó0003 
			//	queryPendingMap.put("creator", "0003"); 
				String jsrNumber = queryUpfatePendRows.getString("RECEIVERNUMBER");
				queryPendingMap.put("receiver", jsrNumber);// ID  ʱó0003
			//	queryPendingMap.put("receiver", "0003");
				Date createTime = queryUpfatePendRows.getDate("RECEIVETIME");
				queryPendingMap.put("createdatetime", sdf.format(createTime));// ̴ʱ
				queryPendingMap.put("receivedatetime", sdf.format(createTime));// 
				queryPendingMap.put("isremark", "2");
				queryPendingMap.put("receivets",new Date().getTime()+"");// ʱ
				String billType="2";
				String url = getUrl(queryUpfatePendRows.getString("RECEIVERNUMBER"),taskId) ;
				queryPendingMap.put("pcurl",url);// pcַ
				String FBIZOBJID =  queryUpfatePendRows.getString("FBIZOBJID");// ҵ
				
				String rcvNum = jsrNumber;  //ʱΪ0003
				//String rcvNum = "0003";
				String receiverNumberBase = Base64.encode(rcvNum.getBytes());
				String mbosUrl = getUrl(taskId, EID, "https://mbos.kdeascloud.com/mbos/page/loadPage?", "10036", ctx,FBIZOBJID);
				mbosUrl = mbosUrl+"&token="+receiverNumberBase+"&isOtherApp=true&path=lczs2";
				System.out.println("mbos ========"+mbosUrl);
				//logger.info("======mbosUrl===="+mbosUrl);
				queryPendingMap.put("appurl", mbosUrl);// appַ
				System.out.println("Ѱ췢("+ new Date().getTime()+ ")"+ JSONObject.fromObject(queryPendingMap).toString());
				//logger.info("Ѱ췢"+ JSONObject.fromObject(queryPendingMap).toString());
				String resultDataStr = HttpRequestUtil.sendPost(ROOT_URL, JSONObject.fromObject(queryPendingMap).toString(), "json");
				System.out.println("ѰӿڷϢ(" + new Date().getTime()+ "):" + resultDataStr);
				//logger.info("ѰӿڷϢ"+ resultDataStr);
				JSONObject resultData = JSONObject.fromObject(resultDataStr);
				if(resultData.get("operResult").equals("1")){
					DbUtil.execute(ctx,"update t_wfr_AssignDetail set CFISSYS = 0 where FASSIGNID = '"+ taskId + "'");
					System.out.println("ɹһѰ");
				}else{
					String resultDataArr = resultData.get("messgae")==null?"":resultData.get("messgae").toString();
					System.out.println("ʹشʧܣʧԭΪ"+ resultDataArr);
				}
			}
			int size = queryUpfatePendRows.size();
			return size;
		}catch(SQLException e){
			e.printStackTrace();
			System.out.println(e.getMessage());
			return -1;
		}catch(Exception e){
			e.printStackTrace();
			System.out.println(e.getMessage());
			return -1;
		}
    }
}