package com.kingdee.eas.custom.risheng;

import com.kingdee.bos.framework.ejb.EJBRemoteException;
import com.kingdee.bos.util.BOSObjectType;
import java.rmi.RemoteException;
import com.kingdee.bos.framework.AbstractBizCtrl;
import com.kingdee.bos.orm.template.ORMObject;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.util.*;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.risheng.*;
import java.lang.String;
import com.kingdee.bos.Context;
import com.kingdee.bos.framework.*;

public class RishengInterfaceFacade extends AbstractBizCtrl implements IRishengInterfaceFacade
{
    public RishengInterfaceFacade()
    {
        super();
        registerInterface(IRishengInterfaceFacade.class, this);
    }
    public RishengInterfaceFacade(Context ctx)
    {
        super(ctx);
        registerInterface(IRishengInterfaceFacade.class, this);
    }
    public BOSObjectType getType()
    {
        return new BOSObjectType("81647F35");
    }
    private RishengInterfaceFacadeController getController() throws BOSException
    {
        return (RishengInterfaceFacadeController)getBizController();
    }
    /**
     *֯ͬOA-User defined method
     *@param data data
     *@return
     */
    public String syncAdminOrgInfo(String data) throws BOSException, EASBizException
    {
        try {
            return getController().syncAdminOrgInfo(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ԱͬOA-User defined method
     *@param data data
     *@return
     */
    public String syncEmployeeInfo(String data) throws BOSException, EASBizException
    {
        try {
            return getController().syncEmployeeInfo(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ͬλϢOA-User defined method
     *@param data data
     *@return
     */
    public String syncPositionInfo(String data) throws BOSException, EASBizException
    {
        try {
            return getController().syncPositionInfo(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ְϢͬOA-User defined method
     *@param data data
     *@return
     */
    public String syncJoblevelInfo(String data) throws BOSException, EASBizException
    {
        try {
            return getController().syncJoblevelInfo(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ԱְϢͬOA-User defined method
     *@param data data
     *@return
     */
    public String syncPersonPositionInfo(String data) throws BOSException, EASBizException
    {
        try {
            return getController().syncPersonPositionInfo(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
}