package com.kingdee.eas.custom.risheng;

import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.utils.StringUtils;
import com.kingdee.bos.*;

import java.io.StringReader;
import java.lang.String;

import com.kingdee.eas.base.wssc.app.trd.webservice.WebServiceConfig;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.risheng.util.HttpRequestSecUtil;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;

public class RishengInterfaceFacadeControllerBean extends AbstractRishengInterfaceFacadeControllerBean
{
    private static Logger logger =
        Logger.getLogger("com.kingdee.eas.custom.risheng.RishengInterfaceFacadeControllerBean");
    /**
     * ֯ͬOA
     */
    @Override
    public String syncAdminOrgInfo(Context ctx, String data) throws BOSException, EASBizException {
    	logger.error("֯ͬӿ");
    
    	try {
	    	Calendar beforeTime = Calendar.getInstance();
		    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	        beforeTime.add(Calendar.MINUTE, -5);// 5֮ǰʱ
	        Date beforeD = beforeTime.getTime();
	        String before5 = simpleDateFormat.format(beforeD);
	        String depSql = "";
	        logger.error("Ϊ"+data.toString());
			if(!StringUtils.isEmpty(data)){
				//вָͬ֯Ϣ
				depSql = "select a.flevel level,a.fid id,a.fname_l2 NAME,a.FNUMBER CODE,b.FNUMBER PARENT_CODE,a.fissealup sup,a.fisousealup ssup,a.freservefieldfirst isnew from t_org_admin a left join t_org_admin b on a.FPARENTID = b.fid where  a.fnumber = '"+data+"'";
			}else {
				//ûвͬҪͬ֯Ϣ
				depSql = "SELECT a.flevel level,a.FID as id,a.FNAME_l2 AS NAME,a.FNUMBER AS CODE,c.Fnumber AS PARENT_CODE,a.fissealup sup,a.fisousealup ssup,a.freservefieldfirst isnew   " +
	        			"FROM t_org_admin  a " +
	        			"left join T_ORG_BASEUNIT b on a.fid = b.fid " +
	        			"left join t_org_admin c on c.fid = a.FPARENTID " +
	        			"where ( to_char(a.FLASTUPDATETIME ,'yyyy-MM-dd HH24:mi:ss') >= '"+before5+"' " +
	        			"or to_char(b.FLASTUPDATETIME ,'yyyy-MM-dd HH24:mi:ss') >= '"+before5+"' )";
			}
			//϶Ĳͬ
			depSql = depSql +" and not exists  (SELECT forgid FROM T_DD_NOSYNCORG dd where a.FID =dd.forgid) ";
			logger.error("depSql="+depSql);
			IRowSet needUpSet = DbUtil.executeQuery(ctx, depSql);
			JSONArray resArr = new JSONArray();
			while(needUpSet.next()){
				String level = needUpSet.getString("level");
				int levelIntVal = Integer.parseInt(level);
				//ŵȼţŽͬ
				if( levelIntVal >= 3){
					Map<String, Object>  checkMap = new HashMap<String,Object>();
					String timestamp = System.currentTimeMillis()/1000+"";
				    logger.error("ʱΪ"+timestamp);
				    String depId = "";//֯ID
				    String depName = "";//֯
				    String depCode = "";//֯
				    String parent_code = "0";//ϼ֯,Ĭ0
				    String invalid = "0"; //״̬ĬǷ()״̬
				    String action = "add";//Ĭadd,༭Ϊ edit
				    String orgCode = "2"; //ֲ룬̶ʢ
				    depId = needUpSet.getString("id");
				    depName = needUpSet.getString("NAME");
				    depCode = needUpSet.getString("CODE");
				    if(!StringUtils.isEmpty(needUpSet.getString("PARENT_CODE"))) {
				    	if(levelIntVal == 3){
				    		logger.error(",ϼĬΪ0");
				    	}else {
				    		parent_code = needUpSet.getString("PARENT_CODE");
				    	}
				    	
				    }
				    if("0".equals(needUpSet.getString("sup") )&& "0".equals(needUpSet.getString("ssup"))){
				    	invalid = "1";
				    }
				    if(!StringUtils.isEmpty(needUpSet.getString("isnew"))) {
				    	action = "edit";
				    }
				    checkMap.put("action", action);
				    checkMap.put("code", depCode);
				    checkMap.put("shortname", depName);
				    checkMap.put("fullname", depName);
				    checkMap.put("org_code", orgCode);
				    checkMap.put("parent_code", parent_code);
				    checkMap.put("canceled", invalid);
				    resArr.add(checkMap);
				    //ýӿ
				    String OA_HR_BASE = WebServiceConfig.getPropertiesValue(ctx, "rishengOAHrBaseUrl");
			 		String urlStr = OA_HR_BASE+"/services/HrmService";
			 		if(resArr.size()>0) {
			 			SyncHRDataInterface syncHRDataInterface= SyncDataFacade.SyncDataFacade("fwoa");
						String returnStr = syncHRDataInterface.syncAdminOrg(resArr.toString(),urlStr);
						logger.error("֯ӿڷϢΪ"+returnStr);
						if(!StringUtils.isEmpty(returnStr)) {
							logger.error("ʼӿڷؽ");
							//  DOM  
							DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance(); 
							//  DOM  
							DocumentBuilder builder = factory.newDocumentBuilder(); 
							//ʹýDocumentʵ
							Document document = builder.parse(new InputSource(new StringReader(returnStr)));
							//ȡresultԪصĽڵб
							NodeList result = document.getElementsByTagName("result");
							if(result.getLength()>0) {
								Node valueNode = result.item(0); 
								String rrr = valueNode.getTextContent(); 
								logger.error("rrr: " + rrr); 
							}
							//ȡֵ
							Element root = document.getDocumentElement();
							NodeList result2 = root.getChildNodes();
							if(result2 != null) {
								if(result2.getLength()>0) {
									Node book=result2.item(0);
									if(book.getNodeType()==Node.ELEMENT_NODE) {
										String value3 = book.getAttributes().getNamedItem("value").getNodeValue();
										logger.error("value3:"+value3);
										if("1".equals(value3)) {
											String updateSQL2 = "/*dialect*/ update t_org_admin Set freservefieldfirst = '0'  where fid = '"+depId+"'";
								 			DbUtil.execute(ctx, updateSQL2);
										}
									}
								}
							}
						}
			 		}else {
			 			logger.error("û֯!");
			 		}
				}
				
			}
		} catch (Exception e) {
			e.printStackTrace();
			logger.error(e.getMessage());
		}
        return null;
    }
    /**
     * ԱͬOA
     */
    @Override
    public String syncEmployeeInfo(Context ctx, String data) throws BOSException, EASBizException {
    	logger.error("ԱϢͬӿ");
    	Calendar beforeTime = Calendar.getInstance();
	    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        beforeTime.add(Calendar.MINUTE, -5);// 5֮ǰʱ
        Date beforeD = beforeTime.getTime();
        String before5 = simpleDateFormat.format(beforeD);
        String needUpSql = "";
        Set<String> set = new HashSet<String>();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
    	try {
    		if(!StringUtils.isEmpty(data)) {
    			if("000000".equals(data)){
    				needUpSql = " SELECT *  FROM t_bd_person a where a.fnumber is not null ";	
    			}else{
    			needUpSql = " SELECT *  FROM t_bd_person a where a.fnumber= '"+data+"' ";
    			}
    		}else {
    			//String personSql = "/*dialect*/ SELECT FNUMBER CODE FROM t_bd_person where FLASTUPDATETIME  >= '"+before5+"'";
    		//	String personSql = "/*dialect*/ SELECT FNUMBER CODE FROM t_bd_person";//20240314 Ϊȫͬ
    			
    			StringBuffer stringBuffer = new StringBuffer();
    			stringBuffer.append("/*dialect*/ SELECT a.FNUMBER code, a.FID,b.FID,c.FID,e.FID,f.fid,g.FID ,h.FID ,i.FID ,j.FID ,k.FID ,l.FID  FROM T_BD_PERSON  a ");//Ա
    			stringBuffer.append(" LEFT OUTER JOIN t_hr_personposition b on a.FID = b.FPERSONID ");//Աְλ
    			stringBuffer.append(" LEFT OUTER JOIN t_org_admin c on b.FPERSONDEP =c.FID "); //Աְλ
    			stringBuffer.append(" LEFT OUTER JOIN T_ORG_POSITION d on b.FPRIMARYPOSITIONID =d.FID  ");//ְλ
    			stringBuffer.append(" LEFT OUTER JOIN T_ORG_JOB e on d.FJOBID =e.FID "); //ְ
    			stringBuffer.append(" LEFT OUTER JOIN T_ORG_JOBCATEGORY f on e.FJOBCATEGORYID =f.FID "); //ְͱ
    			stringBuffer.append(" LEFT OUTER JOIN T_HR_EMPLABORRELATION g on a.FID = g.FPERSONID  "); // ùϵ
    			stringBuffer.append(" LEFT OUTER JOIN T_HR_BDEMPLOYEETYPE  h ON A.FEMPLOYEETYPEID = H.FID ");//ùϵ״̬
    			stringBuffer.append(" LEFT OUTER JOIN T_BD_HRFOLK i ON A.FFOLKID = I.FID ");//
    			stringBuffer.append(" LEFT OUTER JOIN T_BD_REGPERMRESIDENCE j ON A.FREGRESIDENCEID = J.FID ");//ڻ
    			stringBuffer.append(" LEFT OUTER JOIN T_BD_HRPOLITICAL k ON A.FPOLITICALFACEID = K.FID ");//ò
    			stringBuffer.append(" LEFT OUTER JOIN T_BD_HRDIPLOMA l ON A.FHIGHESTDEGREEID = L.FID ");// ѧ
    			stringBuffer.append(" where a.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or b.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or c.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or d.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or e.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or f.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or g.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or h.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or i.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or j.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or k.FLASTUPDATETIME >='"+before5+"' ");
    			stringBuffer.append(" or l.FLASTUPDATETIME >='"+before5+"' ");
    			String personSql = stringBuffer.toString();
    			logger.error("µsqlΪ:>>>>>"+personSql);
    			IRowSet personSet = DbUtil.executeQuery(ctx, personSql);
            	while(personSet.next()){
            		String pNumber = personSet.getString("CODE");
            		set.add(pNumber);
            	}
            //	logger.error("set==="+set.toString());
    	        for(String pNumber :set){
    	        	String upSql = "/*dialect*/ update t_bd_person Set CfIsNeedToOA = '1' where fnumber = '"+pNumber+"'";
    	        	DbUtil.execute(ctx,upSql);
    	        }
    	        //ѡҪµģͬ(unSync is null)Ա
    	     needUpSql = " SELECT *  FROM t_bd_person  a  where a.CfIsNeedToOA = '1' ";
    		}
    		//϶Ĳͬ
    		needUpSql = needUpSql +" and not exists (SELECT fpersonid FROM T_DD_NOSYNCPERSON dd where dd.fpersonid =a.fid ) ";
			
	        IRowSet needUpSet = DbUtil.executeQuery(ctx, needUpSql);
	        while(needUpSet.next()){
	        	JSONArray resArr = new JSONArray();
	        	Map<String, Object>  checkMap = new HashMap<String,Object>();
	        	String action = "add";//Ĭadd,༭Ϊ edit
	        	String pid = "";//ID
	        	String lastname = "";//
	        	String workcode = "";//Ա룬Ψһֵ  hrԱ
	        	String loginid= "";//¼  hrԱ
	        	String password = "123456";//   Ĭϣ123456
	        	String subcompany = "ʢ";// ̶ʢ¡
	        	String department = "";//
	        	String sex = "";//ԱСŮ	
	        	String mobile= "";//ƶ绰
	        	String email= "";//
	        	String birthday = "";//ڣı
	        	String certificatenum= "";//֤
	        	String jobtitle = "";//λƣı  
	        	String jobactivityid = "ERPְ";//ְƣı ̶
	        	String jobgroupid = "ERPְ";//ְƣı ̶
	        	String jobcell = "";//ְ  ȷHRǷУǱش
	        	String joblevel = "1";//֣   
	        	String jobactivitydesc = "";//ְ
	        	String status = "ʽ";//״̬:ʽ-1 ʽԱʱ-2 Ա-3Ƹ-4 Ƹְ-5-6 ݡЧ-7ɾ-10   ȷhrʹõЩùϵ״̬
	        	String folk= "";//壨ı ֵĬ
	        	String nativeplace= "";//ᣨı Ĭ
	        	String regresidentplace= "";//  Ĭ
	        	String maritalstatus= "";//״  Ĭ
	        	String policy= "";//ò Ĭ
	        	String educationlevel= "";//ѧ  Ĭ
	        	String degree= "";//ѧλ Ĭ
	        	String managerid = "";//ֱϼţ ϼְλӦԱ룬Ĭ
	        	String assistantid= "";//ţ
	        	String locationid = "";//칫ƣı
	        	String workroom = "";//칫صƣı ³ϳ
	        	String telephone= "";//칫绰
	        	String mobilecall = "";//绰
	        	String fax = "";//
	        	String systemlanguage = "";//ϵͳԣģ7 ģ9  English8  Ĭϼ
	        	String bememberdate= "";//ڣı
	        	String bepartydate= "";//뵳ڣı
	        	String islabouunion= "";//Ա10
	        	String healthinfo= "";//״
	        	String height= "";//ߣı
	        	String weight= "";//أı
	        	String residentplace= "";//־ס
	        	String homeaddress= "";//ͥϵʽ
	        	String tempresidentnumber= "";//ס֤
	        	String seclevel = "";//ȫ֣  Աְȫ𡱣10 ͨ20 ͨ 60  70 ߹ܣ80 ܾ
	        	String jobcall = "";//ְƣı ȷHRǷУ

	        	
	        	pid = needUpSet.getString("fid");
	        	workcode = needUpSet.getString("fnumber");
	        	lastname = needUpSet.getString("fname_l2");
	        	checkMap.put("workcode", workcode);
	        	checkMap.put("subcompany", subcompany);
	        	//ڲ 
	        	String depCode = "";
				String persondepSQL = "SELECT b.FNAME_l2 depName,b.fnumber depCode,b.FLEVEL level FROM t_hr_personposition a left join  t_org_admin b on b.fid = a.fpersondep  where a.FPERSONID = '"+pid+"'";
				IRowSet personDepRows = DbUtil.executeQuery(ctx, persondepSQL);
				while(personDepRows.next()){
					depCode = personDepRows.getString("depCode");
					String depLevel = personDepRows.getString("level");
					int depLevelIntVal = Integer.parseInt(depLevel);
					if(depLevelIntVal == 1 || depLevelIntVal == 2 || depLevelIntVal == 3) {
						department = personDepRows.getString("depName");
					}else if(depLevelIntVal == 4){
						//ļţҳϼ
						String depName = personDepRows.getString("depName");
						String pDepSQL = "SELECT b.FNAME_l2 pDepName  FROM t_org_admin a left join t_org_admin b on b.fid = a.FPARENTID where a.fnumber = '"+depCode+"'";
						IRowSet pDepRows = DbUtil.executeQuery(ctx, pDepSQL);
						while(pDepRows.next()){
							String pDepName = pDepRows.getString("pDepName");
							department = pDepName+">"+depName;
						}
					}else if(depLevelIntVal == 5) {
						//弶ţϲңֻ鵽6ţ˴ʱд
						String depName = personDepRows.getString("depName");
						String pDepSQL = "SELECT b.FNAME_l2 pDepName,c.FNAME_l2 ppDepName  "
								+ "FROM t_org_admin a "
								+ "left join t_org_admin b on b.fid = a.FPARENTID "
								+ "left join t_org_admin c on c.fid = b.FPARENTID "
								+ "where a.fnumber = '"+depCode+"'";
						IRowSet pDepRows = DbUtil.executeQuery(ctx, pDepSQL);
						while(pDepRows.next()){
							String pDepName = pDepRows.getString("pDepName");
							String ppDepName = pDepRows.getString("ppDepName");
							department = ppDepName+">"+pDepName+">"+depName;
						}
					}else if(depLevelIntVal == 6) {
						//弶ţϲңֻ鵽6ţ˴ʱд
						String depName = personDepRows.getString("depName");
						String pDepSQL = "SELECT b.FNAME_l2 pDepName,c.FNAME_l2 ppDepName,d.FNAME_l2 pppDepName  "
								+ "FROM t_org_admin a "
								+ "left join t_org_admin b on b.fid = a.FPARENTID "
								+ "left join t_org_admin c on c.fid = b.FPARENTID "
								+ "left join t_org_admin d on d.fid = c.FPARENTID "
								+ "where a.fnumber = '"+depCode+"'";
						IRowSet pDepRows = DbUtil.executeQuery(ctx, pDepSQL);
						while(pDepRows.next()){
							String pDepName = pDepRows.getString("pDepName");
							String ppDepName = pDepRows.getString("ppDepName");
							String pppDepName = pDepRows.getString("pppDepName");
							department = pppDepName+">"+ppDepName+">"+pDepName+">"+depName;
						}
					}
					
				}
				checkMap.put("department", department);
	        	checkMap.put("lastname", lastname);
	        	checkMap.put("loginid", workcode);

	        	//ȫ֣  Աְȫ𡱣10 ͨ20 ͨ 60  70 ߹ܣ80 ܾ
	        	seclevel = needUpSet.getString("fidcardissueorg"); 
	        	checkMap.put("seclevel", seclevel);
	        	
	        	String gender = needUpSet.getString("FGENDER");
	        	if("1".equals(gender)){
	        		sex = "";
	        	}else if("2".equals(gender)){
	        		sex = "Ů";
	        	}
	        	checkMap.put("sex", sex);
	        	//ְְ ĵϱע̶Ҫȷϣȴ̶ֵ
				String personPosSQL = "SELECT b.fname_l2 gwName,b.fparentid leader ,c.FNAME_l2 zwName,d.FNAME_l2 zwType,b.FPURPOSE purpose "
						+ "FROM t_hr_personposition a "
						+ "left join T_ORG_POSITION b on b.fid = a.fprimarypositionid "
						+ "left join  T_ORG_JOB c on c.fid = b.fjobid "
						+ "left join T_ORG_JOBCATEGORY d on d.fid = c.fjobcategoryid "
						+ "where a.FPERSONID = '"+pid+"'";
				IRowSet personPosRows = DbUtil.executeQuery(ctx, personPosSQL);
				String leaderId="";
				while(personPosRows.next()){
					if(!StringUtils.isEmpty(personPosRows.getString("zwName"))) {
						jobactivityid = personPosRows.getString("zwName");
					}
//					if(!StringUtils.isEmpty(personPosRows.getString("zwType"))) {
//						jobgroupid = personPosRows.getString("zwType");
//					}
					if(!StringUtils.isEmpty(personPosRows.getString("purpose"))) {
						jobactivitydesc = personPosRows.getString("purpose");
					}
					leaderId =personPosRows.getString("leader");
					jobtitle = personPosRows.getString("gwName");
				}
				//λ
				checkMap.put("jobtitle", jobtitle);
				//ְƹ̶  ERP̶ְְͣ ERPְ   Ҫȷ 
				checkMap.put("jobactivityid", jobactivityid);
				
				checkMap.put("jobgroupid", jobgroupid);
				//jobcell ְƣıȷHRǷУǱش
				
				//joblevel ʲôǰĬΪ1 
				checkMap.put("joblevel", joblevel);
				checkMap.put("jobactivitydesc", jobactivitydesc);
				//ֱϼţ ϼְλӦԱ  String managerid = "";
	        	//ҸְλID
	     /*   	String depAdmPosID2 = "";
	        	String depPosSQL = "SELECT a.fid pid,a.FPARENTID,b.fnumber FROM t_org_position a " +
    					"left join  T_ORG_BaseUnit b on b.fid = a.FAdminOrgUnitID " +
    					"where b.fnumber = '"+depCode+"' and a.FIsRespPosition = 1 ";
	        	IRowSet depPosRows = DbUtil.executeQuery(ctx, depPosSQL);
	        	if(depPosRows.next()) {
	        		depAdmPosID2 = depPosRows.getString("pid");
	        	}
	        	//ٸݲŸְλ personPostionҸ  鲻Ҫְвѯ
	        	String depAdmNumSql = "SELECT a.FPERSONID,a.FPERSONDEP,a.FPRIMARYPOSITIONID,b.FNUMBER bNum   " +
	    				"FROM t_hr_personposition a  " +
	    				"left join t_bd_person b on b.fid = a.FPERSONID " +
	    				"where a.FPrimaryPositionID = '"+depAdmPosID2+"'";
	    		logger.error("depAdmNumSql=="+depAdmNumSql);
	    		IRowSet depAdmNum_Set = DbUtil.executeQuery(ctx, depAdmNumSql);
	    		String businessLeaderID = "";
	    		if(depAdmNum_Set.size()>0){
	    			//˵вŸ  ϲѯ鵽˱
	    			depAdmNum_Set.previous();
	    			while(depAdmNum_Set.next()){
	    				if(!StringUtils.isEmpty(depAdmNum_Set.getString("bNum"))) {
	    					managerid = depAdmNum_Set.getString("bNum");
	    				}
	    			}
	    		}else{
	    			//òûиˣҵְλIDȥְ¼  T_HR_PluralityAddBizBillEntry
	    			String leaderSql = "SELECT a.FPOSITIONID ,a.FPERSONID ,b.FNUMBER as code " +
	    					"FROM T_HR_PluralityAddBizBillentry a left join t_bd_person b on a.FPERSONID = b.fid " +
	    					"where a.FPOSITIONID  = '"+depAdmPosID2+"'";
	    			logger.error("leaderSql=="+leaderSql);
		    		IRowSet jianzhiSet = DbUtil.executeQuery(ctx, leaderSql);
		    		while(jianzhiSet.next()){
		    			if(!StringUtils.isEmpty(jianzhiSet.getString("code"))) {
		    				managerid = jianzhiSet.getString("code");
		    			}
		    		}
	    		}*/
				//20240312 wujiang ϼֶȡְλϼ  ȡŸ
				if(!StringUtils.isEmpty(leaderId)){
					String leadSql ="SELECT b.FNAME_L2,b.FNUMBER  FROM T_HR_PERSONPOSITION a LEFT OUTER JOIN T_BD_PERSON  b ON A.FPERSONID = B.FID where a.FPRIMARYPOSITIONID ='"+leaderId+"'";
					IRowSet rs1 = DbUtil.executeQuery(ctx, leadSql);
					while(rs1.next()){
						managerid = rs1.getString("FNUMBER");
					}
					 if(StringUtils.isEmpty(managerid)){
						// òûиˣҵְλIDȥְ¼  T_HR_PluralityAddBizBillEntry
			    			String leaderSql = "SELECT a.FPOSITIONID ,a.FPERSONID ,b.FNUMBER as code " +
			    					"FROM T_HR_PluralityAddBizBillentry a left join t_bd_person b on a.FPERSONID = b.fid " +
			    					"where a.FPOSITIONID  = '"+leaderId+"'";
			    		//	logger.error("leaderSql=="+leaderSql);
				    		IRowSet jianzhiSet = DbUtil.executeQuery(ctx, leaderSql);
				    		while(jianzhiSet.next()){
				    			if(!StringUtils.isEmpty(jianzhiSet.getString("code"))) {
				    				managerid = jianzhiSet.getString("code");
				    			}
				    		} 
					 }
				}
				//------------------- 20240312------------------------
				
				
	    		checkMap.put("managerid", managerid);
	    		// Ĭϴ
	    		checkMap.put("assistantid", assistantid);
	    		
	    		
	    		//ùϵ״̬
	    	String stausSql = "SELECT b.fnumber as number ,b.FNAME_L2  as name FROM T_HR_EMPLABORRELATION  a " +
	    			"LEFT OUTER JOIN T_HR_BDEMPLOYEETYPE b ON A.FLABORRELATIONSTATEID = B.FID  " +
	    			"where a.FPERSONID ='"+pid+"'";
	    		IRowSet stausSet = DbUtil.executeQuery(ctx, stausSql);
	    		if(stausSet.next()){
	    			String yggxzt = stausSet.getString("number");//ùϵ״̬
	    			status=getOaStatus(yggxzt);
	    		}
	    		
				checkMap.put("status", status);
				
				
				
	        	if(!StringUtils.isEmpty(needUpSet.getString("fncell"))) {
	        		mobile = needUpSet.getString("fncell");
	        	}
	        	if(!StringUtils.isEmpty(needUpSet.getString("femail"))) {
	        		email = needUpSet.getString("femail");
	        	}
	        	if(needUpSet.getDate("fbirthday") != null) {
	        		Date birthdayD = needUpSet.getDate("fbirthday"); 
		        	birthday = dateFormat.format(birthdayD);
	        	}
	        	if(!StringUtils.isEmpty(needUpSet.getString("fidcardno"))) {
	        		certificatenum = needUpSet.getString("fidcardno");
	        	}
	        	
	        	checkMap.put("mobile", mobile);
	        	checkMap.put("email", email);
	        	checkMap.put("birthday", birthday);
	        	checkMap.put("certificatenum", certificatenum);
				
				// ᡢ
	        	String ccKKsql = "SELECT b.FNAME_l2 mzName,a.fnativeplace_l2 jgName,c.FNAME_l2 hklx,a.fhjaddress hkAddress "
	        			+ "FROM t_bd_person a "
	        			+ "left join T_BD_HRFOLK b ON A.FFOLKID = B.FID "
	        			+ "left join T_BD_REGPERMRESIDENCE c ON A.FREGRESIDENCEID = C.FID "
	        			+ "where a.fid = '"+pid+"' ";
	        	IRowSet ccKKRows = DbUtil.executeQuery(ctx, ccKKsql);
	        	while(ccKKRows.next()) {
	        		if(!StringUtils.isEmpty(ccKKRows.getString("mzName"))) {
	        			folk = ccKKRows.getString("mzName");
	        		}
	        		if(!StringUtils.isEmpty(ccKKRows.getString("jgName"))) {
	        			nativeplace = ccKKRows.getString("jgName");
	        			regresidentplace = ccKKRows.getString("jgName");
	        		}
	        	}
	        	checkMap.put("folk", folk);
	        	checkMap.put("nativeplace", nativeplace);
	        	checkMap.put("regresidentplace", regresidentplace);
	        	//״ò
	        	String zzSQL = "SELECT b.FNAME_l2 zzmm,c.FNAME_l2 hyzk "
	        			+ "FROM t_bd_person a "
	        			+ "left join  T_BD_HRPOLITICAL b on b.fid = a.fpoliticalfaceid "
	        			+ "left join T_BD_HRWED c on c.fid = a.fwedid "
	        			+ "where a.fid = '"+pid+"'";
	        	IRowSet zzRows = DbUtil.executeQuery(ctx, zzSQL);
				while(zzRows.next()){
					if(!StringUtils.isEmpty(zzRows.getString("zzmm"))) {
						policy = zzRows.getString("zzmm");
					}
					if(!StringUtils.isEmpty(zzRows.getString("hyzk"))) {
						maritalstatus = zzRows.getString("hyzk");
					}
				}
				checkMap.put("policy", policy);
	        	checkMap.put("maritalstatus", maritalstatus);
	        	//ѧѧλ
	        	String degSQL = "SELECT b.FNAME_l2 xlName,c.FNAME_l2 xwName "
	        			+ "FROM t_bd_person a "
	        			+ "left join T_BD_HRDIPLOMA b on b.fid = a.fhighestdegreeid "
	        			+ "left join T_BD_HRDEGREE c on c.fid = a.fhighestsubdegreeid "
	        			+ "where a.fid = '"+pid+"'";
	        	IRowSet degRows = DbUtil.executeQuery(ctx, degSQL);
				while(degRows.next()){
					if(!StringUtils.isEmpty(degRows.getString("xlName"))) {
						educationlevel = degRows.getString("xlName");
					}
					if(!StringUtils.isEmpty(degRows.getString("xwName"))) {
						degree = degRows.getString("xwName");
					}
				}
				checkMap.put("educationlevel", educationlevel);
	        	checkMap.put("degree", degree);
	        	
	    		
	        	// 칫ƣ칫ص㣬칫绰绰  Ĭޣֵٴ s
	        	
	        	
	        	//жϲű룬ȥֵ³ɳ
	        	if("3".equals(depCode) || "5".equals(depCode) ||"6".equals(depCode) ||"8".equals(depCode) ||"24".equals(depCode)){
	        		locationid = "ϳ";
	        	}else {
	        		locationid = "³";
	        	}
	        	checkMap.put("locationid", locationid);
	        	checkMap.put("workroom", workroom);
	        	checkMap.put("telephone", telephone);
	        	checkMap.put("mobilecall", mobilecall);
	        	checkMap.put("fax", fax);
	        	//ϵͳԣģ7 ģ9  English8  Ĭϼ
	        	checkMap.put("systemlanguage", systemlanguage);
	        	//ڡ뵳ݶ ԱĬϷ ȡֵٶ
	        	checkMap.put("bememberdate", bememberdate);
	        	checkMap.put("bepartydate", bepartydate);
	        	checkMap.put("islabouunion", islabouunion);
	        	//ؽ״̬Ĭޣ֤Ĭ 
	        	checkMap.put("healthinfo", healthinfo);
	        	checkMap.put("height", height);
	        	checkMap.put("weight", weight);
	        	checkMap.put("homeaddress", homeaddress);
	        	checkMap.put("tempresidentnumber", tempresidentnumber);
	        	//־סַ ȡͨŵַ 
	        	if(!StringUtils.isEmpty(needUpSet.getString("faddress_l2"))) {
	        		residentplace = needUpSet.getString("faddress_l2");
	        	}
	        	checkMap.put("residentplace", residentplace);
	        	
	        	//ְƣı ȷHRǷУ ֵ޸
	        	
	        	checkMap.put("jobcall", jobcall);
	        	//action
	        	if(!StringUtils.isEmpty(needUpSet.getString("CFisnew"))) {
			    	action = "edit";
			    }else{
		        	checkMap.put("password", password);//˵ ø
			    }
	        	checkMap.put("action", action);
	        	resArr.add(checkMap);
	        	//ýӿ
	        	String OA_HR_BASE = WebServiceConfig.getPropertiesValue(ctx, "rishengOAHrBaseUrl");
		 		String urlStr = OA_HR_BASE+"/services/HrmService";
		 		if(resArr.size()>0) {
		 			SyncHRDataInterface syncHRDataInterface=SyncDataFacade.SyncDataFacade("fwoa");
					String returnStr = syncHRDataInterface.syncPerson(resArr.toString(),urlStr);
					logger.error("ԱӿڷϢΪ"+returnStr);
					if(!StringUtils.isEmpty(returnStr)) {
					//	logger.error("ʼӿڷؽ");
						//  DOM  
						DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance(); 
						//  DOM  
						DocumentBuilder builder = factory.newDocumentBuilder(); 
						//ʹýDocumentʵ
						Document document = builder.parse(new InputSource(new StringReader(returnStr)));
						//ȡresultԪصĽڵб
						NodeList result = document.getElementsByTagName("result");
						if(result.getLength()>0) {
							Node valueNode = result.item(0); 
							String rrr = valueNode.getTextContent(); 
						//	logger.error("rrr: " + rrr); 
						}
						//ȡֵ
						Element root = document.getDocumentElement();
						NodeList result2 = root.getChildNodes();
						if(result2 != null) {
							if(result2.getLength()>0) {
								Node book=result2.item(0);
								if(book.getNodeType()==Node.ELEMENT_NODE) {
									String value3 = book.getAttributes().getNamedItem("value").getNodeValue();
									logger.error("value3:"+value3);
									if("1".equals(value3)) {
										String updateSQL2 = "/*dialect*/ update t_bd_person Set CFisNew = '0',CfIsNeedToOA = '0' where fid = '"+pid+"'";
							 			DbUtil.execute(ctx, updateSQL2);
									}
								}
							}
						}
					}
		 		}else {
		 			logger.error("ûԱ!");
		 		}
	        }
		} catch (Exception e) {
			e.printStackTrace();
			logger.error(e.getMessage());
		}
        return null;
    }
    private String getOaStatus(String yggxzt) {
    //	HR ʽԱ  001Ա 002ԸԱ 0002 011Ƹ 013ְS09 010ְ 009
    // OA  ʽʱƸְ
    	if("001".equals(yggxzt)||"013".equals(yggxzt)){
    		return "ʽ";
    	}else if("002".equals(yggxzt)||"0002".equals(yggxzt)){
    		return "ʱ";
    	}else if("S09".equals(yggxzt)||"010".equals(yggxzt)||"009".equals(yggxzt)){
    		return "ְ";
    	}else if ("011".equals(yggxzt)){
    		return "";
    	}
    	
		return "ʽ";
	}
	/**
     * ְͬOA
     */
    @Override
    public String syncJoblevelInfo(Context ctx, String data) throws BOSException, EASBizException {
    	logger.error("ְϢͬӿ");
    	Calendar beforeTime = Calendar.getInstance();
	    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        beforeTime.add(Calendar.MINUTE, -5);// 5֮ǰʱ
        Date beforeD = beforeTime.getTime();
        String before5 = simpleDateFormat.format(beforeD);
        Set<String> set = new HashSet<String>();
        String needUpSql = "";
        try {
        	if(!StringUtils.isEmpty(data)) {
    			needUpSql = "/*dialect*/ SELECT * FROM T_HR_JOBLEVEL where fnumber= '"+data+"' ";
    		}else {
    			String personSql = "/*dialect*/ SELECT FNUMBER CODE FROM T_HR_JOBLEVEL where FLASTUPDATETIME  >= '"+before5+"'";
    			IRowSet personSet = DbUtil.executeQuery(ctx, personSql);
            	while(personSet.next()){
            		String pNumber = personSet.getString("CODE");
            		set.add(pNumber);
            	}
            	logger.error("set==="+set.toString());
    	        for(String pNumber :set){
    	        	String upSql = "/*dialect*/ update T_HR_JOBLEVEL Set CfIsNeedToOA = '1' where fnumber = '"+pNumber+"'";
    	        	DbUtil.execute(ctx,upSql);
    	        }
    	        //ѡҪµģͬ(unSync is null)Ա
    	     needUpSql = "/*dialect*/ SELECT *  FROM T_HR_JOBLEVEL where CfIsNeedToOA = '1'";
    		}
	        IRowSet needUpSet = DbUtil.executeQuery(ctx, needUpSql);
	        while(needUpSet.next()){
	        	String timestamp = System.currentTimeMillis()/1000+"";
	        	String name = needUpSet.getString("pname");
	        	String number = needUpSet.getString("CODE");
	        	String pid = needUpSet.getString("id");
	    		JSONObject json = new JSONObject();
	    		json.put("name",name);
	    		json.put("number",number);
	    		json.put("timestamp",timestamp);
	    		CloseableHttpClient httpClient = null;
	    		String resultStr = "";
	    		httpClient = HttpClients.createDefault();
    			Map<String, String> headMap = new HashMap<String, String>();
    			headMap.put("accept", "*/*");
    			headMap.put("connection", "Keep-Alive");
    			headMap.put("Content-Type", "application/json");
    			logger.error("ְͬΪ"+json.toJSONString());
    			logger.error("ְͬͷΪ"+headMap.toString());
    			String TEST_BASEURL = WebServiceConfig.getPropertiesValue(ctx, "rishengBaseUrl");
    			//ַȷ
		 		String url = TEST_BASEURL+"/xxxxxx";
		 		resultStr = HttpRequestSecUtil.sendPost(url, json.toString(), headMap);
		 		JSONObject res = JSONObject.parseObject(resultStr);
		 		String code = res.getString("code");
		 		String message = res.getString("message");
		 		if("true".equals(message)){
		 			String updateSQL2 = "/*dialect*/ update T_HR_JOBLEVEL Set CFisNew = '0' where fid = '"+pid+"'";
		 			DbUtil.execute(ctx, updateSQL2);
		 		}
	        }
		} catch (Exception e) {
			e.printStackTrace();
			logger.error(e.getMessage());
		}
        return null;
    }
    /**
     * ԱְϢͬOA
     */
    @Override
    public String syncPersonPositionInfo(Context ctx, String data) throws BOSException, EASBizException {
    	logger.error("ԱְϢͬӿ");
    	Calendar beforeTime = Calendar.getInstance();
	    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        beforeTime.add(Calendar.MINUTE, -5);// 5֮ǰʱ
        Date beforeD = beforeTime.getTime();
        String before5 = simpleDateFormat.format(beforeD);
        try {
        	Set<String> set = new HashSet<String>();
        	String personSql = "/*dialect*/ SELECT FNUMBER pnumber FROM t_bd_person where FLASTUPDATETIME  >= '"+before5+"'";
			String personPositionSql = "/*dialect*/ SELECT b.FNUMBER pnumber FROM T_HR_PersonPosition a LEFT OUTER JOIN t_bd_person b ON a.FPERSONID = b.FID where  a.FLASTUPDATETIME  >= '"+before5+"'";
			String jzSql = "/*dialect*/ SELECT b.FNUMBER pnumber FROM T_HR_PluralityAddBizBillentry a LEFT OUTER JOIN t_bd_person b ON a.FPERSONID = b.FID  where   a.FLASTUPDATETIME  >= '"+before5+"'"; 
			IRowSet personSet = DbUtil.executeQuery(ctx, personSql);
			while(personSet.next()){
				String pNumber = personSet.getString("pnumber");
				set.add(pNumber);
			}
			IRowSet personPositionSet = DbUtil.executeQuery(ctx, personPositionSql);
			while(personPositionSet.next()){
				String pNumber = personPositionSet.getString("pnumber");
				set.add(pNumber);
			}
			
			IRowSet jzSet = DbUtil.executeQuery(ctx, jzSql);
        	while(jzSet.next()){
        		String pNumber = jzSet.getString("pnumber");
        		set.add(pNumber);
        	}
        	logger.error("set==="+set.toString());
	        for(String pNumber :set){
	        	String upSql = "/*dialect*/ update t_bd_person Set CFrzIsNew = '1' where fnumber = '"+pNumber+"'";
	        	DbUtil.execute(ctx,upSql);
	        }
			//ѡҪµԱ
	        String needUpSql = "/*dialect*/ SELECT fid id,FNAME_l2 pname,FNUMBER CODE,FDeletedStatus status FROM t_bd_person where CFrzIsNew = '1' ";
	        IRowSet needUpSet = DbUtil.executeQuery(ctx, needUpSql);
	        while(needUpSet.next()){
	        	String timestamp = System.currentTimeMillis()/1000+"";
	        	String name = needUpSet.getString("pname");
	        	String number = needUpSet.getString("CODE");
	        	String pid = needUpSet.getString("id");
	        	String status = needUpSet.getString("status"); //״̬ 1 ͨ2
	        	if("1".equals(status)){
	        		status = "ͨ";
	        	}else if("2".equals(status)){
	        		status = "";
	        	}
	    		JSONObject json = new JSONObject();
	    		json.put("name",name);
	    		json.put("number",number);
	    		json.put("timestamp",timestamp);
	    		//šְְ
	    		String depName = "";
	    		String posName = "";
	    		String levelName = "";
	    		StringBuffer positionQueryBuffer = new StringBuffer("/*dialect*/ SELECT ");
	    		positionQueryBuffer.append(" a.FPERSONID,c.FNAME_l2 depName,b.FNAME_l2 levelName,d.FNAME_l2 posName ");
	    		positionQueryBuffer.append(" FROM t_hr_personposition a ");
	    		positionQueryBuffer.append(" left join T_HR_JOBLEVEL b on b.fid = a.FJobLevelID ");
	    		positionQueryBuffer.append(" left join T_ORG_BASEUNIT c on c.fid = a.FPersonDep ");
	    		positionQueryBuffer.append(" left join T_ORG_POSITION d on d.fid = a.FPrimaryPositionID ");
	    		positionQueryBuffer.append(" where a.FPERSONID = '"+pid+"'");
	    		IRowSet queryPosRows = DbUtil.executeQuery(ctx, positionQueryBuffer.toString());
	    		while(queryPosRows.next()){
	    			depName = queryPosRows.getString("depName");
	    			posName = queryPosRows.getString("posName");
	    			levelName = queryPosRows.getString("levelName");
	    		}
	    		json.put("depName",depName);
	    		json.put("posName",posName);
	    		json.put("levelName",levelName);
	    		//ְšְλ
	    		String jzAdminOrgname = "";
	    		String jzPosName = "";
	    		JSONArray jzList = new JSONArray();
	    		StringBuffer jzQueryBuffer = new StringBuffer("/*dialect*/ SELECT ");
	    		jzQueryBuffer.append(" b.FNAME_l2 jzAdminOrgName,c.FNAME_l2 jzPosName ");
	    		jzQueryBuffer.append(" FROM T_HR_PluralityAddBizBillentry a ");
	    		jzQueryBuffer.append(" left join T_ORG_BASEUNIT b on b.fid = a.FAdminOrgID ");
	    		jzQueryBuffer.append(" left join T_ORG_POSITION c on c.fid = a.FPositionID ");
	    		jzQueryBuffer.append(" where a.FPERSONID = '"+pid+"'");
	    		IRowSet queryJzRows = DbUtil.executeQuery(ctx, jzQueryBuffer.toString());
	    		while(queryJzRows.next()){
	    			JSONObject jzObj = new JSONObject();
	    			jzObj.put("jzAdminOrgname", queryJzRows.getString("jzAdminOrgName"));
	    			jzObj.put("jzPosName", queryJzRows.getString("jzPosName"));
	    			jzList.add(jzObj);
	    		}
	    		json.put("jzList",jzList);
	    		CloseableHttpClient httpClient = null;
	    		String resultStr = "";
	    		httpClient = HttpClients.createDefault();
    			Map<String, String> headMap = new HashMap<String, String>();
    			headMap.put("accept", "*/*");
    			headMap.put("connection", "Keep-Alive");
    			headMap.put("Content-Type", "application/json");
    			logger.error("ְϢͬΪ"+json.toJSONString());
    			logger.error("ְϢͬͷΪ"+headMap.toString());
    			String TEST_BASEURL = WebServiceConfig.getPropertiesValue(ctx, "rishengBaseUrl");
    			//ַȷ
		 		String url = TEST_BASEURL+"/xxxxxx";
		 		resultStr = HttpRequestSecUtil.sendPost(url, json.toString(), headMap);
		 		JSONObject res = JSONObject.parseObject(resultStr);
		 		String code = res.getString("code");
		 		String message = res.getString("message");
		 		if("true".equals(message)){
		 			String updateSQL2 = "/*dialect*/ update t_bd_person Set CFrzIsNew = '0' where fid = '"+pid+"'";
		 			DbUtil.execute(ctx, updateSQL2);
		 		}
	        }
		} catch (Exception e) {
			e.printStackTrace();
			logger.error(e.getMessage());
		}
        return null;
    }
    /**
     * λϢOA
     */
    @Override
    public String syncPositionInfo(Context ctx, String data) throws BOSException, EASBizException {
    	logger.error("λϢͬӿ");
    	Calendar beforeTime = Calendar.getInstance();
	    SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        beforeTime.add(Calendar.MINUTE, -5);// 5֮ǰʱ
        Date beforeD = beforeTime.getTime();
        String before5 = simpleDateFormat.format(beforeD);
        String needUpSql = "";
        Set<String> set = new HashSet<String>();
        try {
        	if(!StringUtils.isEmpty(data)) {
    			needUpSql = "/*dialect*/ SELECT * FROM T_ORG_Position where fnumber= '"+data+"' ";
    		}else {
    			String personSql = "/*dialect*/ SELECT FNUMBER CODE FROM T_ORG_Position where FLASTUPDATETIME  >= '"+before5+"'";
    			IRowSet personSet = DbUtil.executeQuery(ctx, personSql);
            	while(personSet.next()){
            		String pNumber = personSet.getString("CODE");
            		set.add(pNumber);
            	}
            	logger.error("set==="+set.toString());
    	        for(String pNumber :set){
    	        	String upSql = "/*dialect*/ update T_ORG_Position Set CfIsNeedToOA = '1' where fnumber = '"+pNumber+"'";
    	        	DbUtil.execute(ctx,upSql);
    	        }
    	     //ѡҪµģͬ(unSync is null)ְλ
    	     needUpSql = "/*dialect*/ SELECT *  FROM T_ORG_Position where CfIsNeedToOA = '1'";
    		}
	        IRowSet needUpSet = DbUtil.executeQuery(ctx, needUpSql);
	        JSONArray resArr = new JSONArray();
	        while(needUpSet.next()){
	        	String posCode = needUpSet.getString("FNUMBER");
	        	//Ǹ߹ְλͬǷͬOAΪ0 
	        	if("0001".equals(posCode) || "0002".equals(posCode)|| "0003".equals(posCode)|| "0004".equals(posCode)
	        	 || "0005".equals(posCode)|| "0006".equals(posCode)|| "0007".equals(posCode)|| "0008".equals(posCode)
	        	 || "0009".equals(posCode)|| "0010".equals(posCode)|| "0011".equals(posCode)|| "0505".equals(posCode)){
	        		String updSql = "/*dialect*/ update T_ORG_Position Set CfIsNeedToOA = '0' where fnumber = '"+posCode+"'";
    	        	DbUtil.execute(ctx,updSql);
	        	}else {
	        		Map<String, Object>  checkMap = new HashMap<String,Object>();
		        	String action ="add";//addӣedit༭deleteɾ
		        	String jobtitlecode="";//λ룬Ψһֵ  
		        	String jobtitlename="";//λ  
		        	String jobtitleremark="";//λȫ  
		        	String jobtitledept="";//λű   Ϊ
		        	String jobgroupid="505";//ְ  OAһͳһְ   ERPְ
		        	if(!StringUtils.isEmpty(needUpSet.getString("CFisnew"))) {
				    	action = "edit";
				    }
		        	checkMap.put("action", action);
		        	jobtitlecode = needUpSet.getString("fname_l2");
		        	jobtitlename = needUpSet.getString("fname_l2");
		        	jobtitleremark = needUpSet.getString("fname_l2");
		        	checkMap.put("jobtitlecode", jobtitlecode);
		        	checkMap.put("jobtitlename", jobtitlename);
		        	checkMap.put("jobtitleremark", jobtitleremark);
		        	checkMap.put("jobtitledept", jobtitledept);
		        	//ȷ 
		        	checkMap.put("jobgroupid", jobgroupid);
		        	resArr.add(checkMap);
		        	//ýӿ
		        	String OA_HR_BASE = WebServiceConfig.getPropertiesValue(ctx, "rishengOAHrBaseUrl");
			 		String urlStr = OA_HR_BASE+"/services/HrmService";
			 		if(resArr.size()>0) {
			 			SyncHRDataInterface syncHRDataInterface=SyncDataFacade.SyncDataFacade("fwoa");
						String returnStr = syncHRDataInterface.syncPosition(resArr.toString(),urlStr);
						if(!StringUtils.isEmpty(returnStr)) {
							logger.error("ʼӿڷؽ");
							//  DOM  
							DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance(); 
							//  DOM  
							DocumentBuilder builder = factory.newDocumentBuilder(); 
							//ʹýDocumentʵ
							Document document = builder.parse(new InputSource(new StringReader(returnStr)));
							//ȡresultԪصĽڵб
							NodeList result = document.getElementsByTagName("result");
							if(result.getLength()>0) {
								Node valueNode = result.item(0); 
								String rrr = valueNode.getTextContent(); 
								logger.error("rrr: " + rrr); 
							}
							//ȡֵ
							Element root = document.getDocumentElement();
							NodeList result2 = root.getChildNodes();
							if(result2 != null) {
								if(result2.getLength()>0) {
									Node book=result2.item(0);
									if(book.getNodeType()==Node.ELEMENT_NODE) {
										String value3 = book.getAttributes().getNamedItem("value").getNodeValue();
										logger.error("value3:"+value3);
										if("1".equals(value3)) {
											String updateSQL2 = "/*dialect*/ update T_ORG_Position Set CFisNew = '0',CfIsNeedToOA = '0' where fnumber = '"+posCode+"'";
								 			DbUtil.execute(ctx, updateSQL2);
										}
									}
								}
								
							}
						}
			 		}else {
			 			logger.error("ûְλ!");
			 		}
			 		
	        	}
	        }
		} catch (Exception e) {
			e.printStackTrace();
			logger.error(e.getMessage());
		}
        return null;
    }
    
}