package com.kingdee.eas.custom.risheng;

import com.kingdee.bos.framework.ejb.EJBRemoteException;
import com.kingdee.bos.util.BOSObjectType;
import java.rmi.RemoteException;
import com.kingdee.bos.framework.AbstractBizCtrl;
import com.kingdee.bos.orm.template.ORMObject;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.util.*;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.risheng.*;
import java.lang.String;
import com.kingdee.bos.Context;
import com.kingdee.bos.framework.*;

public class RishengPendingMessageFacade extends AbstractBizCtrl implements IRishengPendingMessageFacade
{
    public RishengPendingMessageFacade()
    {
        super();
        registerInterface(IRishengPendingMessageFacade.class, this);
    }
    public RishengPendingMessageFacade(Context ctx)
    {
        super(ctx);
        registerInterface(IRishengPendingMessageFacade.class, this);
    }
    public BOSObjectType getType()
    {
        return new BOSObjectType("4FA99C68");
    }
    private RishengPendingMessageFacadeController getController() throws BOSException
    {
        return (RishengPendingMessageFacadeController)getBizController();
    }
    /**
     *Ϣ-User defined method
     *@param data data
     *@return
     */
    public String sendPendingMsg(String data) throws BOSException, EASBizException
    {
        try {
            return getController().sendPendingMsg(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
    /**
     *ѰϢ-User defined method
     *@param data data
     *@return
     */
    public String sendDoneMsg(String data) throws BOSException, EASBizException
    {
        try {
            return getController().sendDoneMsg(getContext(), data);
        }
        catch(RemoteException err) {
            throw new EJBRemoteException(err);
        }
    }
}